<?php
/*
 * Insert HTML editor button plugin for Joomla! file   
 */ 
	define( '_JEXEC', 1 );
	define( 'DS', DIRECTORY_SEPARATOR );
	define( 'JPATH_BASE', realpath( '..'.DS.'..'.DS.'..'.DS ) );	


	
	require_once(JPATH_BASE . DS . 'includes' . DS . 'defines.php');
	require_once(JPATH_BASE . DS . 'includes' . DS . 'framework.php');

 
//	$mainframe = JFactory::getApplication('administrator');		

	// Boot the DI container.
	$container = \Joomla\CMS\Factory::getContainer();

	// Alias the session service key to the web session service.
	$container->alias(\Joomla\Session\SessionInterface::class, 'session.web.site');

	$mainframe = $container->get(\Joomla\CMS\Application\AdministratorApplication::class);

	//echo "<pre>"; print_r($mainframe); die;
	jimport( 'joomla.plugin.plugin' );	
 
	$ih_name = addslashes( $_GET['ih_name'] );
?>
<html>
	<head>
	<title><?= JText::_('Special Textbox Editor') ?></title>
	<meta http-equiv="content-type" content="text/html;charset=utf-8" />
	<link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css" >
	<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
	<?php 

	$path  = juri::root();

	if (strpos($path, 'plugins') !== false) {
	   $plugins_path =  explode("plugins", $path);
	   $path = $plugins_path[0];
	}
	$media_path = JPATH_SITE . '/media/ggpkg/';
	$dirs = array_filter(glob($media_path.'*'), 'is_dir');
    $medias = array();
	foreach ($dirs as $key => $dir) {

		$explode = explode("/", $dir);
		$filename = end($explode); 

		$ext = pathinfo($filename, PATHINFO_EXTENSION);
		if($ext == "ggpkg"){
          $medias[$key]["filename"] = $filename;
          if(file_exists($dir."/preview.jpg")){
          	$preview_path = $path.'/media/ggpkg/'.$filename."/preview.jpg";
          }else{
            $preview_path = $path.'/plugins/content/ggpkg_import/include/ggpkg.png';
          }
          $medias[$key]["path"] = $preview_path;
		}

	}
    ?>
	<script type="text/javascript">
		jQuery(document).ready(function(){

			window.parent.title_change();

		});
		jQuery(document).on('click','#upload-submit', function(e) {
            e.preventDefault();
            if( jQuery('#upload-file')[0].files.length > 0){
			    var file_data = jQuery('#upload-file').prop('files')[0];   
			    var form_data = new FormData();                  
			    form_data.append('file', file_data); 
			    form_data.append('preview', jQuery('input[name=preview]:checked').val());
			    form_data.append('width', jQuery('input[name=width]').val());
			    form_data.append('height', jQuery('input[name=height]').val());
			    jQuery(".file_div").hide();   
			   jQuery(".file_div").parent().append("<div class='please_wait'>Please wait...</div>");                        
			    jQuery.ajax({
			        url: "<?php echo $path;?>?option=com_ajax&group=content&plugin=ggpkgimport&format=raw",
			        cache: false,
			        contentType: false,
			        processData: false,
			        data: form_data,                         
			        type: 'post',
			        success: function(response){
			        	jQuery(".please_wait").remove();
			            var returnedData = JSON.parse(response);

			            if(returnedData.error){
			                alert(returnedData.msg);
			                jQuery(".file_div").show();   
			            }else{
			                jQuery("#html_gg").html(returnedData.file);
			                var result =  document.getElementById("html_gg").innerHTML ;
			                window.parent.Spbox_ClickCallback( '<?= $ih_name ?>', result);
			            }
			        }
			    });
			}else{
				jQuery('#upload-file').focus();
			}    
		})
 
		function InsertHtmlDialogokClick() {
		  var result =  document.getElementById("html_gg").innerHTML ;
		  window.parent.Spbox_ClickCallback( '<?= $ih_name ?>', result);
			  
		}
 
		function InsertHtmlDialogcancelClick() {
			window.parent.document.getElementById('sbox-window').close();		  
		}
			
	</script>
	<style type="text/css">
		fieldset.file_div, .insert_gg {
		    padding: 13px 21px;
		}
		.file_div table tr td, .insert_gg table tr td{
			padding-bottom: 10px;
		}
		/* The container */
		.perview {
		  display: block;
		  position: relative;
		  padding-left: 35px;
		  margin-bottom: 12px;
		  cursor: pointer;
		  font-size: 17px;
		  -webkit-user-select: none;
		  -moz-user-select: none;
		  -ms-user-select: none;
		  user-select: none;
		}
		.perview_outer p {
		      font-size: 15px;
              color: #656363;
		}

		/* Hide the browser's default checkbox */
		.perview input {
		  position: absolute;
		  opacity: 0;
		  cursor: pointer;
		  height: 0;
		  width: 0;
		}

		/* Create a custom checkbox */
		.checkmark {
		  position: absolute;
		  top: 0;
		  left: 0;
		  height: 23px;
		  width: 23px;
		  border: 1px solid #b5b5b5;
		}

		/* On mouse-over, add a grey background color */
		.perview:hover input ~ .checkmark {
		  background-color: #ccc;
		}

		/* When the checkbox is checked, add a blue background */
		.perview input:checked ~ .checkmark {
		  background-color: #2196F3;
		}

		/* Create the checkmark/indicator (hidden when not checked) */
		.checkmark:after {
		  content: "";
		  position: absolute;
		  display: none;
		}

		/* Show the checkmark when checked */
		.perview input:checked ~ .checkmark:after {
		  display: block;
		}

		/* Style the checkmark/indicator */
		.checkmark:after {
		  left: 9px;
		  top: 5px;
		  width: 5px;
		  height: 10px;
		  border: solid white;
		  border-width: 0 3px 3px 0;
		  -webkit-transform: rotate(45deg);
		  -ms-transform: rotate(45deg);
		  transform: rotate(45deg);
		}
		.medias{
			margin: 0
		}
		.medias ul {
		  list-style-type: none;
		  padding: 0;
		}

		.medias li {
		  display: inline-block;
		}

		.medias input[type="checkbox"][id^="cb"] {
		  display: none;
		}

		.medias label {
		  border: 1px solid #fff;
		  display: block;
		  position: relative;
		  margin: 6px;
		  cursor: pointer;
		  -webkit-touch-callout: none;
		  -webkit-user-select: none;
		  -khtml-user-select: none;
		  -moz-user-select: none;
		  -ms-user-select: none;
		  user-select: none;
		}

		.medias label::before {
		  background-color: white;
		  color: white;
		  content: " ";
		  display: block;
		  border-radius: 50%;
		  border: 1px solid grey;
		  position: absolute;
		  top: -5px;
		  left: -5px;
		  width: 25px;
		  height: 25px;
		  text-align: center;
		  line-height: 28px;
		  transition-duration: 0.4s;
		  transform: scale(0);
		}

		.medias label img {
		  height: 166px;
		  width: 166px;
		  transition-duration: 0.2s;
		  transform-origin: 50% 50%;
		}

		.medias :checked+label {
		  border-color: #ddd;
		}

		.medias :checked+label::before {
		  content: "✓";
		  background-color: grey;
		  transform: scale(1);
		  z-index: 999;
		}

		.medias :checked+label img {
		  transform: scale(0.9);
		  box-shadow: 0 0 5px #333;
		  z-index: -1;
		}
		
	</style>
	</head>
	<body>
		<div class="row medias">
			<ul>
				<?php 
				foreach ($medias as $key => $media) { ?>
					<li><input type="checkbox" value="<?php echo $media['filename'];?>" id="cb<?php echo $key;?>" style="display: none" />
					    <label for="cb<?php echo $key;?>"><img src="<?php echo $media['path'];?>" file_name="<?php echo $media['filename'];?>" /></label>
					</li>
				<?php } ?>
			</ul>	
		</div>
		<form name="inserthtml" id="inserthtml" onSubmit="return false;">
			<fieldset class="file_div">
				<table class="properties" style="width: 100%;">
					<tr>
						
						<td nowrap class="perview_outer">
							<label class="perview">Start Preview
							  <input type="checkbox" name="preview">
							  <span class="checkmark"></span>
							</label>
							<p>If the player should start with a preview image and a play button.</p>
						</td>
					</tr>
				</table>
				<table class="properties" style="width: 100%;">		
				    
					<tr>
						<td nowrap>
							<label>Width:</label>
							<input  class="form-control" type='text' name='width'> 
						</td>
					</tr>
					<tr>
						<td nowrap>
							<label>Height:</label>
							<input class="form-control" type='text' name='height'> 
						</td>
					</tr>			
					
					<tr>
						<td nowrap>
							<label>Upload File:</label>
							<input class="form-control" required type='file' accept='.ggpkg' id='upload-file' name='Filedata'> 
						</td>
					</tr>	
					
					<tr>
						<td nowrap>
							<button class='btn btn-primary' id='upload-submit'><span class='icon-upload icon-white'></span> Start Upload</button>
							<button class='btn btn-primary' id='save-submit' style="display: none;"><span class='icon-upload icon-white'></span> Save</button>
						</td>
					</tr>
				</table>
			</fieldset>
			<fieldset class="insert_gg" style="display: none">
				<table class="properties" >
					<tr>
						<td colspan="1" align="left" valign="bottom" nowrap style="width: 546px;">
							<div id="html_gg"></div>
						</td>
					</tr>
					<tr>
						<td colspan="1" align="left" valign="bottom" nowrap>
							<input type="submit" value="<?= JText::_('Insert') ?>" onClick="InsertHtmlDialogokClick()" class="bt btn btn-primary" >
						</td>
					</tr>
				</table>
			</fieldset>
		</form>
		<script type="text/javascript">
			jQuery("body").find(".medias").find("li").click(function(){
				jQuery(this).toggleClass("img_select");
				if(jQuery(this).find("input[type=checkbox]:checked").length > 0){
					jQuery(this).find("input").prop("checked",false);
				}else{
					jQuery("body").find(".medias").find("input[type=checkbox]").prop("checked",false);
					jQuery(this).find("input").prop("checked",true);
				}
				
				if(jQuery("body").find(".medias").find("input[type=checkbox]:checked").length > 0){
					setTimeout(function(){
						jQuery("html, body").animate({ scrollTop: $(document).height() }, 1000);
					},500)
				   
                   jQuery("#upload-submit").hide();
                   jQuery("#save-submit").show();
                   jQuery("#upload-file").parent().hide();
				}else{
				   jQuery("#upload-submit").show();
                   jQuery("#save-submit").hide();
                   jQuery("#upload-file").parent().show();

				}

			});
			jQuery(document).on('click','#save-submit', function(e) {
	            e.preventDefault();
	            var filename = jQuery("body").find(".medias").find("input[type=checkbox]:checked").val(); 
	            var preview = jQuery('input[name=preview]:checked').val(); 
	            var width = jQuery('input[name=width]').val(); 
	            var height = jQuery('input[name=height]').val(); 

	            if(preview != undefined){
                    var start_preview = ' start_preview="true" ';
				}else{
					var start_preview = ' start_preview="false" ';
				}
	            if(width != ""){
	            	var width_html = ' width="'+width+'" ';
	            }else{
	            	var width_html = '';
	            }
	            if(height != ""){
	            	var height_html = ' height="'+height+'" ';
	            }else{
	            	var height_html = '';
	            }
	            var html_data = '{ggpkg file="'+filename+'" '+start_preview+width_html+height_html+'}';
	            jQuery("#html_gg").html(html_data);
	            var result =  document.getElementById("html_gg").innerHTML ;
	            window.parent.Spbox_ClickCallback( '<?= $ih_name ?>', result);
				
				       
			});
		</script>
	</body>
</html>